###################################################################
# Copyright 2001 by Object Craft P/L, Melbourne, Australia.
# 
#                         All Rights Reserved
# 
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted,
# provided that the above copyright notice appear in all copies and that
# both that copyright notice and this permission notice appear in
# supporting documentation, and that the name of Object Craft
# is not be used in advertising or publicity pertaining to
# distribution of the software without specific, written prior
# permission.
# 
# OBJECT CRAFT DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
# INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
# EVENT SHALL OBJECT CRAFT BE LIABLE FOR ANY SPECIAL, INDIRECT OR
# CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
# USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
# OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# 
###################################################################
import cgi, sys, os, string

class Request:
    def __init__(self):
        self.__fields = cgi.FieldStorage()
        self.__sent_headers = 0

    def has_field(self, name):
        return self.__fields.has_key(name)

    def field_value(self, name):
        field = self.__fields[name]
        if type(field) is type([]):
            value = []
            for elem in field:
                value.append(elem.value)
            return value
        return field.value

    def field_names(self):
        return self.__fields.keys()

    def get_uri(self):
        return os.environ['REQUEST_URI']

    def get_servername(self):
        return os.environ['SERVER_NAME']

    def get_header(self, name):
        env_name = 'HTTP_' + string.upper(string.replace(name, '-', '_'))
        return os.environ.get(env_name)

    def write_header(self, name, value):
        if not self.__sent_headers:
            sys.stdout.write('%s: %s\n' % (name, value))

    def end_headers(self):
        if not self.__sent_headers:
            sys.stdout.write('\n')
            self.__sent_headers = 1

    def redirect(self, loc):
        self.write_header('Location', loc)
        self.write_header('Status', '301 Moved Permanently')
        self.end_headers()

    def write_content(self, data):
        self.end_headers()
        sys.stdout.write(data)
        sys.stdout.flush()

    def status(self, num):
        pass
